#ifndef _CSA_STRING_H
#define _CSA_STRING_H

#include "osl/state/numEffectState.h"

#include <boost/scoped_ptr.hpp>
#include <iosfwd>
namespace osl
{
  namespace record
  {
    class Record;

    namespace csa
    {
      // use of string is intentionally avoided here in order to reduce the cost of compilation 
      class CsaString
      {
      private:
	boost::scoped_ptr<Record> rec;
      public:
	CsaString(const char *recordString);
	~CsaString();
    
	Record const& getRecord() const;
	const NumEffectState getInitialState() const;
      };
    } // namespace csa
  } // namespace record
  using record::csa::CsaString;
} // namespace osl
#endif /* _CSA_STRING_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
